scala.util.parsing.combinator

# JavaTokenParsers

#### trait JavaTokenParsers extends RegexParsers

`JavaTokenParsers` differs from scala.util.parsing.combinator.RegexParsers by adding the following definitions:

- `ident`
- `wholeNumber`
- `decimalNumber`
- `stringLiteral`
- `floatingPointNumber`

Source
  JavaTokenParsers.scala

Linear Supertypes
RegexParsers, Parsers, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. JavaTokenParsers
2. RegexParsers
3. Parsers
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type Elem = Char

   the type of input elements the provided parsers consume (When consuming invidual characters, a parser is typically called a scanner, which produces tokens that are consumed by what is normally called a parser.

   the type of input elements the provided parsers consume (When consuming invidual characters, a parser is typically called a scanner, which produces tokens that are consumed by what is normally called a parser. Nonetheless, the same principles apply, regardless of the input type.)

   Definition Classes
     RegexParsers → Parsers

2. #### case class Error(msg: String, next: Input) extends NoSuccess with Product with Serializable

   The fatal failure case of ParseResult: contains an error-message and the remaining input.

3. #### case class Failure(msg: String, next: Input) extends NoSuccess with Product with Serializable

   The failure case of `ParseResult`: contains an error-message and the remaining input.

4. #### type Input = Reader[Elem]

   The parser input is an abstract reader of input elements, i.

   The parser input is an abstract reader of input elements, i.e. the type of input the parsers in this component expect.

   Definition Classes
     Parsers

5. #### sealed abstract class NoSuccess extends ParseResult[Nothing]

   A common super-class for unsuccessful parse results.

6. #### trait OnceParser[+T] extends Parser[T]

   A parser whose `~` combinator disallows back-tracking.

7. #### sealed abstract class ParseResult[+T] extends AnyRef

   A base class for parser results.

8. #### abstract class Parser[+T] extends (Input) ⇒ ParseResult[T]

   The root class of parsers.

9. #### case class Success[+T](result: T, next: Input) extends ParseResult[T] with Product with Serializable

   The success case of `ParseResult`: contains the result and the remaining input.

10. #### case class ~[+a, +b](_1: a, _2: b) extends Product with Serializable

    A wrapper over sequence of matches.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from JavaTokenParsers to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (JavaTokenParsers, B)

   Implicit information
     This member is added by an implicit conversion from JavaTokenParsers to ArrowAssoc[JavaTokenParsers] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### object NoSuccess

   An extractor so `NoSuccess(msg, next)` can be used in matches.

9. #### def OnceParser[T](f: (Input) ⇒ ParseResult[T]): Parser[T] with OnceParser[T]

   Definition Classes
     Parsers

10. #### def Parser[T](f: (Input) ⇒ ParseResult[T]): Parser[T]

    Definition Classes
      Parsers

11. #### def accept[U](expected: String, f: PartialFunction[Elem, U]): Parser[U]

    The parser that matches an element in the domain of the partial function `f`.

    The parser that matches an element in the domain of the partial function `f`.

    If `f` is defined on the first element in the input, `f` is applied to it to produce this parser's result.

    Example: The parser `accept("name", {case Identifier(n) => Name(n)})` accepts an `Identifier(n)` and returns a `Name(n)`

    expected

      a description of the kind of element this parser expects (for error messages)

    f

      a partial function that determines when this parser is successful and what its output is

    returns

      A parser that succeeds if `f` is applicable to the first element of the input, applying `f` to it to produce the result.

    Definition Classes
      Parsers

12. #### def accept[ES](es: ES)(implicit arg0: (ES) ⇒ List[Elem]): Parser[List[Elem]]

    A parser that matches only the given list of element `es`.

    A parser that matches only the given list of element `es`.

    `accept(es)` succeeds if the input subsequently provides the elements in the list `es`.

    es

      the list of expected elements

    returns

      a Parser that recognizes a specified list of elements

    Definition Classes
      Parsers

13. #### implicit def accept(e: Elem): Parser[Elem]

    A parser that matches only the given element `e`.

    A parser that matches only the given element `e`.

    The method is implicit so that elements can automatically be lifted to their parsers. For example, when parsing `Token`s, `Identifier("new")` (which is a `Token`) can be used directly, instead of first creating a `Parser` using `accept(Identifier("new"))`.

    e

      the `Elem` that must be the next piece of input for the returned parser to succeed

    returns

      a `tParser` that succeeds if `e` is the next available input.

    Definition Classes
      Parsers

14. #### def acceptIf(p: (Elem) ⇒ Boolean)(err: (Elem) ⇒ String): Parser[Elem]

    A parser matching input elements that satisfy a given predicate.

    A parser matching input elements that satisfy a given predicate.

    `acceptIf(p)(el => "Unexpected "+el)` succeeds if the input starts with an element `e` for which `p(e)` is true.

    p

      A predicate that determines which elements match.

    err

      A function from the received element into an error message.

    returns

      A parser for elements satisfying p(e).

    Definition Classes
      Parsers

15. #### def acceptMatch[U](expected: String, f: PartialFunction[Elem, U]): Parser[U]

    The parser that matches an element in the domain of the partial function `f`.

    The parser that matches an element in the domain of the partial function `f`.

    If `f` is defined on the first element in the input, `f` is applied to it to produce this parser's result.

    Example: The parser `acceptMatch("name", {case Identifier(n) => Name(n)})` accepts an `Identifier(n)` and returns a `Name(n)`

    expected

      a description of the kind of element this parser expects (for error messages)

    f

      a partial function that determines when this parser is successful and what its output is

    returns

      A parser that succeeds if `f` is applicable to the first element of the input, applying `f` to it to produce the result.

    Definition Classes
      Parsers

16. #### def acceptSeq[ES](es: ES)(implicit arg0: (ES) ⇒ Iterable[Elem]): Parser[List[Elem]]

    A parser that matches only the given scala.collection.Iterable collection of elements `es`.

    A parser that matches only the given scala.collection.Iterable collection of elements `es`.

    `acceptSeq(es)` succeeds if the input subsequently provides the elements in the iterable `es`.

    es

      the list of expected elements

    returns

      a Parser that recognizes a specified list of elements

    Definition Classes
      Parsers

17. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

18. #### def chainl1[T, U](first: ⇒ Parser[T], p: ⇒ Parser[U], q: ⇒ Parser[(T, U) ⇒ T]): Parser[T]

    A parser generator that, roughly, generalises the `rep1sep` generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    A parser generator that, roughly, generalises the `rep1sep` generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    first

      a parser that parses the first element

    p

      a parser that parses the subsequent elements

    q

      a parser that parses the token(s) separating the elements, yielding a left-associative function that combines two elements into one

    Definition Classes
      Parsers

19. #### def chainl1[T](p: ⇒ Parser[T], q: ⇒ Parser[(T, T) ⇒ T]): Parser[T]

    A parser generator that, roughly, generalises the rep1sep generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    A parser generator that, roughly, generalises the rep1sep generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    From: J. Fokker. Functional parsers. In J. Jeuring and E. Meijer, editors, Advanced Functional Programming, volume 925 of Lecture Notes in Computer Science, pages 1--23. Springer, 1995.

    p

      a parser that parses the elements

    q

      a parser that parses the token(s) separating the elements, yielding a left-associative function that combines two elements into one

    Definition Classes
      Parsers

20. #### def chainr1[T, U](p: ⇒ Parser[T], q: ⇒ Parser[(T, U) ⇒ U], combine: (T, U) ⇒ U, first: U): Parser[U]

    A parser generator that generalises the `rep1sep` generator so that `q`, which parses the separator, produces a right-associative function that combines the elements it separates.

    A parser generator that generalises the `rep1sep` generator so that `q`, which parses the separator, produces a right-associative function that combines the elements it separates. Additionally, the right-most (last) element and the left-most combining function have to be supplied.

    rep1sep(p: Parser[T], q) corresponds to chainr1(p, q ^^ cons, cons, Nil) (where val cons = (x: T, y: List[T]) => x :: y)

    p

      a parser that parses the elements

    q

      a parser that parses the token(s) separating the elements, yielding a right-associative function that combines two elements into one

    combine

      the "last" (left-most) combination function to be applied

    first

      the "first" (right-most) element to be combined

    Definition Classes
      Parsers

21. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

22. #### def commit[T](p: ⇒ Parser[T]): Parser[T]

    Wrap a parser so that its failures become errors (the `|` combinator will give up as soon as it encounters an error, on failure it simply tries the next alternative).

    Wrap a parser so that its failures become errors (the `|` combinator will give up as soon as it encounters an error, on failure it simply tries the next alternative).

    Definition Classes
      Parsers

23. #### def decimalNumber: Parser[String]

    Number following one of these rules:

    Number following one of these rules:

    - An integer. For example: `13`
    - An integer followed by a decimal point. For example: `3.`
    - An integer followed by a decimal point and fractional part. For example: `3.14`
    - A decimal point followed by a fractional part. For example: `.1`

24. #### def elem(e: Elem): Parser[Elem]

    A parser that matches only the given element `e`.

    A parser that matches only the given element `e`.

    `elem(e)` succeeds if the input starts with an element `e`.

    e

      the `Elem` that must be the next piece of input for the returned parser to succeed

    returns

      a `Parser` that succeeds if `e` is the next available input (and returns it).

    Definition Classes
      Parsers

25. #### def elem(kind: String, p: (Elem) ⇒ Boolean): Parser[Elem]

    A parser matching input elements that satisfy a given predicate.

    A parser matching input elements that satisfy a given predicate.

    `elem(kind, p)` succeeds if the input starts with an element `e` for which `p(e)` is true.

    kind

      The element kind, used for error messages

    p

      A predicate that determines which elements match.

    returns

    Definition Classes
      Parsers

26. #### def ensuring(cond: (JavaTokenParsers) ⇒ Boolean, msg: ⇒ Any): JavaTokenParsers

    Implicit information
      This member is added by an implicit conversion from JavaTokenParsers to Ensuring[JavaTokenParsers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### def ensuring(cond: (JavaTokenParsers) ⇒ Boolean): JavaTokenParsers

    Implicit information
      This member is added by an implicit conversion from JavaTokenParsers to Ensuring[JavaTokenParsers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

28. #### def ensuring(cond: Boolean, msg: ⇒ Any): JavaTokenParsers

    Implicit information
      This member is added by an implicit conversion from JavaTokenParsers to Ensuring[JavaTokenParsers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

29. #### def ensuring(cond: Boolean): JavaTokenParsers

    Implicit information
      This member is added by an implicit conversion from JavaTokenParsers to Ensuring[JavaTokenParsers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

30. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

32. #### def err(msg: String): Parser[Nothing]

    A parser that results in an error.

    A parser that results in an error.

    msg

      The error message describing the failure.

    returns

      A parser that always fails with the specified error message.

    Definition Classes
      Parsers

33. #### def failure(msg: String): Parser[Nothing]

    A parser that always fails.

    A parser that always fails.

    msg

      The error message describing the failure.

    returns

      A parser that always fails with the specified error message.

    Definition Classes
      Parsers

34. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

35. #### def floatingPointNumber: Parser[String]

    A number following the rules of `decimalNumber`, with the following optional additions:

    A number following the rules of `decimalNumber`, with the following optional additions:

    - Preceded by a negative sign
    - Followed by `e` or `E` and an optionally signed integer
    - Followed by `f`, `f`, `d` or `D` (after the above rule, if both are used)

36. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from JavaTokenParsers to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

37. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

38. #### def guard[T](p: ⇒ Parser[T]): Parser[T]

    A parser generator for guard expressions.

    A parser generator for guard expressions. The resulting parser will fail or succeed just like the one given as parameter but it will not consume any input.

    p

      a `Parser` that is to be applied to the input

    returns

      A parser that returns success if and only if `p` succeeds but never consumes any input

    Definition Classes
      Parsers

39. #### def handleWhiteSpace(source: CharSequence, offset: Int): Int

    Method called to handle whitespace before parsers.

    Method called to handle whitespace before parsers.

    It checks `skipWhitespace` and, if true, skips anything matching `whiteSpace` starting from the current offset.

    source

      The input being parsed.

    offset

      The offset into `source` from which to match.

    returns

      The offset to be used for the next parser.

    Attributes
      protected
    Definition Classes
      RegexParsers

40. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

41. #### def ident: Parser[String]

    Anything that is a valid Java identifier, according to The Java Language Spec.

    Anything that is a valid Java identifier, according to The Java Language Spec. Generally, this means a letter, followed by zero or more letters or numbers.

42. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

43. #### implicit def literal(s: String): Parser[String]

    A parser that matches a literal string

    A parser that matches a literal string

    Definition Classes
      RegexParsers

44. #### def log[T](p: ⇒ Parser[T])(name: String): Parser[T]

    A helper method that turns a `Parser` into one that will print debugging information to stdout before and after being applied.

    A helper method that turns a `Parser` into one that will print debugging information to stdout before and after being applied.

    Definition Classes
      Parsers

45. #### def mkList[T]: (~[T, List[T]]) ⇒ collection.immutable.List[T]

    Given a concatenation with a repetition (list), move the concatenated element into the list

    Given a concatenation with a repetition (list), move the concatenated element into the list

    Definition Classes
      Parsers

46. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

47. #### def not[T](p: ⇒ Parser[T]): Parser[Unit]

    Wrap a parser so that its failures and errors become success and vice versa -- it never consumes any input.

    Wrap a parser so that its failures and errors become success and vice versa -- it never consumes any input.

    Definition Classes
      Parsers

48. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

49. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

50. #### def opt[T](p: ⇒ Parser[T]): Parser[Option[T]]

    A parser generator for optional sub-phrases.

    A parser generator for optional sub-phrases.

    `opt(p)` is a parser that returns `Some(x)` if `p` returns `x` and `None` if `p` fails.

    p

      A `Parser` that is tried on the input

    returns

      a `Parser` that always succeeds: either with the result provided by `p` or with the empty result

    Definition Classes
      Parsers

51. #### def parse[T](p: Parser[T], in: Reader): ParseResult[T]

    Parse some prefix of reader `in` with parser `p`.

    Parse some prefix of reader `in` with parser `p`.

    Definition Classes
      RegexParsers

52. #### def parse[T](p: Parser[T], in: CharSequence): ParseResult[T]

    Parse some prefix of character sequence `in` with parser `p`.

    Parse some prefix of character sequence `in` with parser `p`.

    Definition Classes
      RegexParsers

53. #### def parse[T](p: Parser[T], in: Reader[Char]): ParseResult[T]

    Parse some prefix of reader `in` with parser `p`.

    Parse some prefix of reader `in` with parser `p`.

    Definition Classes
      RegexParsers

54. #### def parseAll[T](p: Parser[T], in: CharSequence): ParseResult[T]

    Parse all of character sequence `in` with parser `p`.

    Parse all of character sequence `in` with parser `p`.

    Definition Classes
      RegexParsers

55. #### def parseAll[T](p: Parser[T], in: Reader): ParseResult[T]

    Parse all of reader `in` with parser `p`.

    Parse all of reader `in` with parser `p`.

    Definition Classes
      RegexParsers

56. #### def parseAll[T](p: Parser[T], in: Reader[Char]): ParseResult[T]

    Parse all of reader `in` with parser `p`.

    Parse all of reader `in` with parser `p`.

    Definition Classes
      RegexParsers

57. #### def phrase[T](p: Parser[T]): Parser[T]

    A parser generator delimiting whole phrases (i.

    A parser generator delimiting whole phrases (i.e. programs).

    `phrase(p)` succeeds if `p` succeeds and no input is left over after `p`.

    p

      the parser that must consume all input for the resulting parser to succeed.

    returns

      a parser that has the same result as `p`, but that only succeeds if `p` consumed all the input.

    Definition Classes
      RegexParsers → Parsers

58. #### def positioned[T <: Positional](p: ⇒ Parser[T]): Parser[T]

    `positioned` decorates a parser's result with the start position of the input it consumed.

    `positioned` decorates a parser's result with the start position of the input it consumed. If whitespace is being skipped, then it is skipped before the start position is recorded.

    p

      a `Parser` whose result conforms to `Positional`.

    returns

      A parser that has the same behaviour as `p`, but which marks its result with the start position of the input it consumed after whitespace has been skipped, if it didn't already have a position.

    Definition Classes
      RegexParsers → Parsers

59. #### implicit def regex(r: Regex): Parser[String]

    A parser that matches a regex string

    A parser that matches a regex string

    Definition Classes
      RegexParsers

60. #### def rep[T](p: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for repetitions.

    A parser generator for repetitions.

    `rep(p)` repeatedly uses `p` to parse the input until `p` fails (the result is a List of the consecutive results of `p`).

    p

      a `Parser` that is to be applied successively to the input

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input.

    Definition Classes
      Parsers

61. #### def rep1[T](first: ⇒ Parser[T], p0: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for non-empty repetitions.

    A parser generator for non-empty repetitions.

    `rep1(f, p)` first uses `f` (which must succeed) and then repeatedly uses `p` to parse the input until `p` fails (the result is a `List` of the consecutive results of `f` and `p`)

    first

      a `Parser` that parses the first piece of input

    p0

      a `Parser` that is to be applied successively to the rest of the input (if any) -- evaluated at most once, and only when necessary

    returns

      A parser that returns a list of results produced by first applying `f` and then repeatedly `p` to the input (it only succeeds if `f` matches).

    Definition Classes
      Parsers
    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) The `p0` call-by-name arguments is evaluated at most once per constructed Parser object, instead of on every need that arises during parsing.

62. #### def rep1[T](p: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for non-empty repetitions.

    A parser generator for non-empty repetitions.

    `rep1(p)` repeatedly uses `p` to parse the input until `p` fails -- `p` must succeed at least once (the result is a `List` of the consecutive results of `p`)

    p

      a `Parser` that is to be applied successively to the input

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input (and that only succeeds if `p` matches at least once).

    Definition Classes
      Parsers

63. #### def rep1sep[T](p: ⇒ Parser[T], q: ⇒ Parser[Any]): Parser[List[T]]

    A parser generator for non-empty repetitions.

    A parser generator for non-empty repetitions.

    `rep1sep(p, q)` repeatedly applies `p` interleaved with `q` to parse the input, until `p` fails. The parser `p` must succeed at least once.

    p

      a `Parser` that is to be applied successively to the input

    q

      a `Parser` that parses the elements that separate the elements parsed by `p` (interleaved with `q`)

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input (and that only succeeds if `p` matches at least once). The results of `p` are collected in a list. The results of `q` are discarded.

    Definition Classes
      Parsers

64. #### def repN[T](num: Int, p: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for a specified number of repetitions.

    A parser generator for a specified number of repetitions.

    `repN(n, p)` uses `p` exactly `n` time to parse the input (the result is a `List` of the `n` consecutive results of `p`).

    num

      the exact number of times `p` must succeed

    p

      a `Parser` that is to be applied successively to the input

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input (and that only succeeds if `p` matches exactly `n` times).

    Definition Classes
      Parsers

65. #### def repsep[T](p: ⇒ Parser[T], q: ⇒ Parser[Any]): Parser[List[T]]

    A parser generator for interleaved repetitions.

    A parser generator for interleaved repetitions.

    `repsep(p, q)` repeatedly uses `p` interleaved with `q` to parse the input, until `p` fails. (The result is a `List` of the results of `p`.)

    Example: `repsep(term, ",")` parses a comma-separated list of term's, yielding a list of these terms.

    p

      a `Parser` that is to be applied successively to the input

    q

      a `Parser` that parses the elements that separate the elements parsed by `p`

    returns

      A parser that returns a list of results produced by repeatedly applying `p` (interleaved with `q`) to the input. The results of `p` are collected in a list. The results of `q` are discarded.

    Definition Classes
      Parsers

66. #### def skipWhitespace: Boolean

    Definition Classes
      RegexParsers

67. #### def stringLiteral: Parser[String]

    Double quotes (`"`) enclosing a sequence of:

    Double quotes (`"`) enclosing a sequence of:

    - Any character except double quotes, control characters or backslash (`\`)
    - A backslash followed by another backslash, a single or double quote, or one of the letters `b`, `f`, `n`, `r` or `t`
    - `\` followed by `u` followed by four hexadecimal digits
    Annotations
      @migration
    Migration

      (Changed in version 2.10.0) `stringLiteral` allows escaping single and double quotes, but not forward slashes any longer.

68. #### def success[T](v: T): Parser[T]

    A parser that always succeeds.

    A parser that always succeeds.

    v

      The result for the parser

    returns

      A parser that always succeeds, with the given result `v`

    Definition Classes
      Parsers

69. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

70. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

71. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

72. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

73. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

74. #### val whiteSpace: Regex

    Attributes
      protected
    Definition Classes
      RegexParsers

75. #### def wholeNumber: Parser[String]

    An integer, without sign or with a negative sign.

76. #### def →[B](y: B): (JavaTokenParsers, B)

    Implicit information
      This member is added by an implicit conversion from JavaTokenParsers to ArrowAssoc[JavaTokenParsers] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from JavaTokenParsers to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (javaTokenParsers: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from JavaTokenParsers to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (javaTokenParsers: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def lastNoSuccess: NoSuccess

   Definition Classes
     Parsers
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) lastNoSuccess was not thread-safe and will be removed in 2.11.0

2. #### def lastNoSuccess_=(x: NoSuccess): Unit

   Definition Classes
     Parsers
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) lastNoSuccess was not thread-safe and will be removed in 2.11.0

3. #### def x: JavaTokenParsers

   Implicit information
     This member is added by an implicit conversion from JavaTokenParsers to ArrowAssoc[JavaTokenParsers] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (javaTokenParsers: ArrowAssoc[JavaTokenParsers]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

4. #### def x: JavaTokenParsers

   Implicit information
     This member is added by an implicit conversion from JavaTokenParsers to Ensuring[JavaTokenParsers] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (javaTokenParsers: Ensuring[JavaTokenParsers]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from RegexParsers

### Inherited from Parsers

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from JavaTokenParsers to StringAdd

### Inherited by implicit conversion any2stringfmt from JavaTokenParsers to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from JavaTokenParsers to ArrowAssoc[JavaTokenParsers]

### Inherited by implicit conversion any2Ensuring from JavaTokenParsers to Ensuring[JavaTokenParsers]

### Ungrouped